                                // stack.cc

// implementation file of stack.h

#include "stack.h"

// definisci qui tutte le istanze che ti servono
template class stack<int>;
template class stack<char>;

template <class T>
void stack<T>::stackcpy(const stack<T>& s)
{
   n=s.n;

   if (s.sp != NULL)
   {
      node* tail= new_node();

      const node* ssp=s.sp; // cursor on the list s.sp
      node* tmp;

      // first copy the top
      sp= tail;
      sp->val = ssp->val;

      // then all the other elements in order
      while ((ssp = ssp->prev) != NULL)
      {
         tmp=new_node();

         tail->prev = tmp;
         tail = tmp;
         tail->val = ssp->val;
      }
      tail->prev = NULL;
   }
   else
      sp=NULL;
}

template <class T>
const stack<T>& stack<T>::operator=(const stack<T>& s)
{
   if (this != &s)
   {
      clear();
      stackcpy(s);
   }
   return (*this);
}

template <class T>
void stack<T>::push(const T& val)
{
   node* tmp= new_node();

   tmp->val=val;
   tmp->prev=sp;
   sp=tmp;
   ++n;
}

template <class T>
T stack<T>::pop( )
{
   ExceptionIfEmpty();

   T val = sp->val;
   node* tmp= sp;
   sp=sp->prev;
   delete tmp;
   --n;

   return(val);
}

template <class T>
void stack<T>::clear( )
{
   for (node* q = sp; q != NULL; q = sp)        // or sp != NULL
   {
      sp = sp->prev;
      delete q;
   }
   n=0;
}

template <class T>
bool stack<T>::full( )
{
   node* test= new node;

   if (test==NULL)
      return true;

   delete test;
   return false;
}

template <class T>
T& stack<T>::top( )
{
   ExceptionIfEmpty();

   return sp->val;
}

template <class T>
T& stack<T>::dtop( )
{
   push(top( ));

   return sp->val;
}

template <class T>
bool stack<T>::operator == (const stack<T>& s)
{
   if (this == &s)
      return true;
   if (n != s.n)
      return false;
   for (node *c1=sp, *c2=s.sp; c1 != NULL; c1=c1->prev, c2=c2->prev)
      if (c1->val!=c2->val)
         return false;
   return true;
}
